// mm_srv client for Avisynth v2.5.x Copyright 2009 N099
//

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
#pragma once

class MMCLAvs : public IClip
{
private:
	VideoInfo _vi;
	mm_srv_handle* _hmms;

public:
	MMCLAvs(const char* filename, int fmt,
		bool interlaced, bool tff, IScriptEnvironment* env);
	~MMCLAvs() { CleanUp(); }

	//IClip
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
	bool __stdcall GetParity(int) { return false; }
	void __stdcall GetAudio(void*, __int64, __int64, IScriptEnvironment*) {}
	void __stdcall SetCacheHints(int cachehints,int frame_range) {}
	const VideoInfo& __stdcall GetVideoInfo() { return _vi; }

	//class factory
	static AVSValue __cdecl CreateMMCLAvs(AVSValue args, void*, IScriptEnvironment* env);

private:
	void CleanUp();
	void SetVideoInfo(bool interlaced, bool tff);
	static int Str2MM_FMT(const char* str, bool interlaced);
	static int MM_FMT2VideoinfoFormat(unsigned long fmt);
};
