//----------------------------------------------------------------------------------
//		Memory Mapped T[o[(o̓vOC)  for AviUtl
//----------------------------------------------------------------------------------
#ifndef __MM_SRV_H__
#define __MM_SRV_H__
#include <windows.h>
#include <tchar.h>

/* T[o[̃o[W */
#define MM_SRV_VER 2

/* tH[}bg */
/*
 * MM_FMT_RGB24   RGB24 DIB`i{gAbvj
 * MM_FMT_RGB24R  RGB24gbv_E
 * MM_FMT_YUY2    YUY2gbv_E[y,u,y,v]
 * MM_FMT_YV12    YV12gbv_E[y][v][u]
 * MM_FMT_YV12I   C^[[XYV12[y][v][u]
 * MM_FMT_YC48    PIXEL_YCgbv_E
 */
#define MM_FMT_RGB24  1
#define MM_FMT_RGB24R 2
#define MM_FMT_YUY2   3
#define MM_FMT_YV12   4
#define MM_FMT_YV12I  5
#define MM_FMT_YC48   6

/* bZ[W */
#define MM_MSG_OPEN  (WM_APP + 2)
#define MM_MSG_GET   (WM_APP + 3)
#define MM_MSG_HIT   (WM_APP + 4)
#define MM_MSG_CLOSE (WM_APP + 5)

/* ^CAEg(msec) */
#define MM_SRV_TMOUT (10*1000)

/* ACgTCY(Byte)̍ől */
#define MM_SRV_ALIGN_MAX 128U

/* LiꉞALLP64zj */
typedef struct _mm_srv_map_data {
	DWORD ver;    /* T[õo[W */
	DWORD format; /* 摜tH[}bg */
	DWORD w;      /*  (Pixel) */
	DWORD h;      /*  (Pixel) */
	DWORD pitch;  /* XgCh (Byte) */
	DWORD frame;  /* St[ */
	DWORD rate;   /* t[[g */
	DWORD scale;  /* t[[g */
	DWORD nbuf;   /* obt@ */
	DWORD idxofs; /* t[ԍe[uւ̃ItZbg */
	DWORD bufofs; /* f[^ItZbge[uւ̃ItZbg */
	DWORD evtofs; /* CxgIuWFNgւ̃ItZbg */
	HWND  hMsg;   /* vpbZ[WEChEnh */
} mm_srv_map_data;

#ifndef __MM_SRV_C__

/* Ǘpnh */
typedef struct _mm_srv_handle {
	HANDLE hMap;
	HANDLE hEvt;
	VOID  *pData;
	DWORD format;
	DWORD w;
	DWORD h;
	DWORD pitch;
	DWORD frame;
	DWORD rate;
	DWORD scale;
	DWORD *pOffs;
	volatile LONG *pIndex;
	CRITICAL_SECTION cs;
} mm_srv_handle;

/* ʐMp֐ */
void close_mm_srv(mm_srv_handle *h);

/* Ǘnh̃I[v */
/*
 * 
 *   map_name: T[o쐬 *.avu t@CipX͂ȂĂOKj
 *   format: MM_FMT_xxx ̂ꂩ
 *   align: 1C̃f[^TCYwoCg̔{ɂ
 *          01Ƃ݂ȂAtH[}bgɂĂ͐
 * Ԃl
 *   mm_srv_handle ւ̃|C^BG[ NULL ԂB
 */
mm_srv_handle * open_mm_srv(const TCHAR *map_name, DWORD format, DWORD align)
{
	mm_srv_handle *h;
	mm_srv_map_data *m;
	const TCHAR *name;
	DWORD_PTR result = 0;

	/* ̓`FbN */
	if(!map_name || format < MM_FMT_RGB24
		|| format > MM_FMT_YC48 || align > MM_SRV_ALIGN_MAX)
	{
		return NULL;
	}

	/* pX */
	name = _tcsrchr(map_name, TEXT('\\'));
	if(name){
		name = _tcsinc(name);
	}else{
		name = map_name;
	}

	/* Ǘf[^̈m */
	h = (mm_srv_handle*)HeapAlloc(GetProcessHeap(), 0, sizeof(mm_srv_handle));
	if(NULL == h){
		/* mێs */
		return h;
	}
	ZeroMemory(h, sizeof(mm_srv_handle));

	/* get_frame_mm_srv()̂߂̃NeBJZNV */
	InitializeCriticalSection(&h->cs);

	/* L̃I[v */
	h->hMap = OpenFileMapping(FILE_MAP_WRITE, FALSE, name);
	if(NULL == h->hMap){
		close_mm_srv(h);
		return NULL;
	}

	h->pData = MapViewOfFile(h->hMap, FILE_MAP_WRITE, 0, 0, 0);
	if(NULL == h->pData){
		close_mm_srv(h);
		return NULL;
	}
	m = (mm_srv_map_data*)(h->pData);
	
	/* o[W̃`FbN */
	if(MM_SRV_VER != m->ver){
		close_mm_srv(h);
		return NULL;
	}

	/* CxgIuWFNgJ */
	h->hEvt = OpenEventA(SYNCHRONIZE, FALSE,
		(CHAR*)((BYTE*)h->pData + m->evtofs));
	if(NULL == h->hEvt){
		close_mm_srv(h);
		return NULL;
	}

	/* ł͈Ӗ͖ǁAoȂƂ */
	EnterCriticalSection(&h->cs);

	/* łɗpς݂ǂ"format"Ń`FbN */
	if(m->format){
		LeaveCriticalSection(&h->cs);
		close_mm_srv(h);
		return NULL;
	}

	/* T[o֐ݒNGXg */
	SendMessageTimeout(m->hMsg, MM_MSG_OPEN,
		format, align, SMTO_NORMAL, MM_SRV_TMOUT, &result);
	if(result == 0){
		/* T[o[Ƃ̐ڑɎs or ^CAEg */
		LeaveCriticalSection(&h->cs);
		close_mm_srv(h);
		return NULL;
	}

	LeaveCriticalSection(&h->cs);

	/* ۂɐݒ肳ꂽ摜Rs[ */
	h->format = m->format;
	h->w      = m->w;
	h->h      = m->h;
	h->pitch  = m->pitch;
	h->frame  = m->frame;
	h->rate   = m->rate;
	h->scale  = m->scale;
	h->pOffs  = (DWORD*)((BYTE*)h->pData + m->bufofs);
	h->pIndex = (volatile LONG*)((BYTE*)h->pData + m->idxofs);

	return h;
}

/* t[f[^̃|C^𓾂 */
/*
 * 
 *   h: mm_srv_handle ւ̃|C^
 *   frame: 0n܂t[ԍ
 * Ԃl
 *   t[f[^ւ̃|C^BG[ NULL ԂB
 */
void * get_frame_mm_srv(mm_srv_handle *h, DWORD frame)
{
	unsigned char *p;
	mm_srv_map_data *m;
	DWORD pos;

	if(NULL == h){
		return NULL;
	}
	
	p = (unsigned char*)(h->pData);
	m = (mm_srv_map_data*)(h->pData);
	if(NULL == p){
		return NULL;
	}else if(h->format == 0 || m->format == 0){
		/* ڑ or T[o[G[ */
		return NULL;
	}else if(frame >= h->frame){
		return NULL;
	}

	/* f[^łɑ݂Ă邩`FbN */
	pos = frame % m->nbuf;
	if(h->pIndex[pos] == (LONG)frame){
		PostMessage(m->hMsg, MM_MSG_HIT, 0, frame);
		return (void*)(p + h->pOffs[pos]);
	}

	EnterCriticalSection(&h->cs);

	/* f[^̂ŗv */
	if(!PostMessage(m->hMsg, MM_MSG_GET, 0, frame)){
		/* T[o[G[ */
		LeaveCriticalSection(&h->cs);
		return NULL;
	}
	
	/* f[^pӂł܂ő҂ */
	if(WAIT_OBJECT_0 != WaitForSingleObject(h->hEvt, MM_SRV_TMOUT)){
		/* Ԑ؂ or T[o[G[ */
		LeaveCriticalSection(&h->cs);
		return NULL;
	}

	LeaveCriticalSection(&h->cs);

	/* ēx`FbN */
	if(h->pIndex[pos] == (LONG)frame){
		return (void*)(p + h->pOffs[pos]);
	}else{
		return NULL;
	}
}

/* ڑI */
/*
 * 
 *   h: mm_srv_handle ւ̃|C^
 */
void close_mm_srv(mm_srv_handle *h)
{
	mm_srv_map_data *m;

	if(NULL == h || NULL == h->pData){
		return;
	}

	m = (mm_srv_map_data*)(h->pData);

	/* ڑȂ΃T[oɏIʒm */
	if(h->format != 0){
		PostMessage(m->hMsg, MM_MSG_CLOSE, 0, 0);
	}

	UnmapViewOfFile(h->pData);
	CloseHandle(h->hEvt);
	CloseHandle(h->hMap);
	h->pData = NULL;

	DeleteCriticalSection(&h->cs);

	HeapFree(GetProcessHeap(), 0, h);
}

#endif /* __MM_SRV_C__ */
#endif /* __MM_SRV_H__ */
